/*
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Nicolas Payneau (Mia-Software) - initial API and implementation
 */
package org.eclipse.gmt.modisco.workflow.driver.discoverer.execution;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.gmt.modisco.discoverersmanager.ui.launch.DiscovererLaunchConfigurationDelegate;
import org.eclipse.gmt.modisco.workflow.DriverExecutionInterface;

public class DiscovererExecute implements DriverExecutionInterface {

	public DiscovererExecute() {
	}
	
	public void launch(ILaunchConfigurationWorkingCopy configuration, ILaunch launch) {
		try {
			DiscovererLaunchConfigurationDelegate delegate = new DiscovererLaunchConfigurationDelegate();
			delegate.launch(configuration,ILaunchManager.RUN_MODE, launch,new NullProgressMonitor());
		} catch (CoreException e) {
			e.printStackTrace();
		}
	}
}
