/*******************************************************************************
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Nicolas Payneau (Mia-Software) - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.modisco.workflow.driver.modiscoworkflow.ui;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.gmt.modisco.workflow.AbstractDriverCore;
import org.eclipse.gmt.modisco.workflow.DriverInterface;
import org.eclipse.gmt.modisco.workflow.MoDiscoWorkflowLaunchConstants;
import org.eclipse.gmt.modisco.workflow.driver.modiscoworkflow.Constant;
import org.eclipse.gmt.modisco.workflow.modiscoworkflow.Direction;
import org.eclipse.gmt.modisco.workflow.modiscoworkflow.WorkParameter;

public class LaunchDriverMoDiscoWorkflow extends AbstractDriverCore implements DriverInterface {
	
	public String getTypeLaunchConfig() {
		return Constant.typeLaunchConfiguration;
	}

	@SuppressWarnings("unchecked")
	public List<WorkParameter> getParameters(ILaunchConfiguration configuration) {
		List<WorkParameter> parameters = new ArrayList<WorkParameter>();
		try {
			String id = configuration.getAttribute(MoDiscoWorkflowLaunchConstants.idWorkflow,(String)null);
			WorkParameter param = createOneWorkParameter(MoDiscoWorkflowLaunchConstants.idWorkflow,Direction.IN,"Workflow engine id",true,String.class);
			param.setValue(createStringValue(configuration.getAttribute(MoDiscoWorkflowLaunchConstants.idWorkflow,(String)null)));
			parameters.add(param);	
			if(id.equals(MoDiscoWorkflowLaunchConstants.idMinimaliste)){
				WorkParameter param2 = createOneWorkParameter(MoDiscoWorkflowLaunchConstants.moDiscoListMinimalist,Direction.IN,"List of Works",true,List.class);
				param2.setValue(createValueStringList(configuration.getAttribute(MoDiscoWorkflowLaunchConstants.moDiscoListMinimalist,(List<String>)null)));
				parameters.add(param2);
			}else{
				WorkParameter param2 = createOneWorkParameter(MoDiscoWorkflowLaunchConstants.moDiscoListSerialize,Direction.IN,"List of Works",true,List.class);
				param2.setValue(createValueStringList(configuration.getAttribute(MoDiscoWorkflowLaunchConstants.moDiscoListSerialize,(List<String>)null)));
				parameters.add(param2);
				WorkParameter param3 = createOneWorkParameter(MoDiscoWorkflowLaunchConstants.moDiscoWorkNumber,Direction.IN,"Number of Work",true,Integer.class);
				param3.setValue(createIntegerValue(configuration.getAttribute(MoDiscoWorkflowLaunchConstants.moDiscoWorkNumber,0)));
				parameters.add(param3);
				WorkParameter param4 = createOneWorkParameter(MoDiscoWorkflowLaunchConstants.resourcePath,Direction.IN,"Resource path",true,String.class);
				param4.setValue(createStringValue(configuration.getAttribute(MoDiscoWorkflowLaunchConstants.resourcePath,(String)null)));
				parameters.add(param4);
			}
	
		} catch (CoreException e) {
			e.printStackTrace();
		}
		return parameters;
	}
}
