/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.eclipse.gmt.modisco.workflow.modiscowork;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.gmt.modisco.workflow.modiscowork.ModiscoworkFactory
 * @model kind="package"
 * @generated
 */
public interface ModiscoworkPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "modiscowork";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/gmt/modisco/workflow";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org.eclipse.gmt.modisco.workflow.modiscowork";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ModiscoworkPackage eINSTANCE = org.eclipse.gmt.modisco.workflow.modiscowork.impl.ModiscoworkPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.gmt.modisco.workflow.modiscowork.impl.MoDiscoWorkImpl <em>Mo Disco Work</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.impl.MoDiscoWorkImpl
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.impl.ModiscoworkPackageImpl#getMoDiscoWork()
	 * @generated
	 */
	int MO_DISCO_WORK = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_DISCO_WORK__NAME = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_DISCO_WORK__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_DISCO_WORK__INDEX = 2;

	/**
	 * The number of structural features of the '<em>Mo Disco Work</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_DISCO_WORK_FEATURE_COUNT = 3;


	/**
	 * Returns the meta object for class '{@link org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork <em>Mo Disco Work</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mo Disco Work</em>'.
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork
	 * @generated
	 */
	EClass getMoDiscoWork();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getName()
	 * @see #getMoDiscoWork()
	 * @generated
	 */
	EAttribute getMoDiscoWork_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getType()
	 * @see #getMoDiscoWork()
	 * @generated
	 */
	EAttribute getMoDiscoWork_Type();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getIndex <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Index</em>'.
	 * @see org.eclipse.gmt.modisco.workflow.modiscowork.MoDiscoWork#getIndex()
	 * @see #getMoDiscoWork()
	 * @generated
	 */
	EAttribute getMoDiscoWork_Index();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ModiscoworkFactory getModiscoworkFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.gmt.modisco.workflow.modiscowork.impl.MoDiscoWorkImpl <em>Mo Disco Work</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.gmt.modisco.workflow.modiscowork.impl.MoDiscoWorkImpl
		 * @see org.eclipse.gmt.modisco.workflow.modiscowork.impl.ModiscoworkPackageImpl#getMoDiscoWork()
		 * @generated
		 */
		EClass MO_DISCO_WORK = eINSTANCE.getMoDiscoWork();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MO_DISCO_WORK__NAME = eINSTANCE.getMoDiscoWork_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MO_DISCO_WORK__TYPE = eINSTANCE.getMoDiscoWork_Type();

		/**
		 * The meta object literal for the '<em><b>Index</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MO_DISCO_WORK__INDEX = eINSTANCE.getMoDiscoWork_Index();

	}

} //ModiscoworkPackage
